﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using Persist.Services;
using System.Collections;

namespace Business.Controller
{
    public class PersonController
    {
        PersonServices PersonServices;
        ReserveController ReserveController;

        public PersonController()
        {
            this.PersonServices = new PersonServices();
            this.ReserveController = new ReserveController();
        }

        public bool Create(Person person)
        {
            bool status = false;

            try
            {
                PersonServices.Create(person);
                status = true;
            }
            catch
            {
            }

            return status;
        }

        public bool Update(Person person)
        {
            bool status = false;

            try
            {
                Person result = Find(person.PersonID);

                if (result != null)
                {
                    PersonServices.Update(person);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public bool Delete(int personID)
        {
            bool status = false;

            try
            {
                status = DeleteReserves(personID);

                if (!status)
                    throw new Exception();

                status = false;
                PersonServices.RefreshContext();

                Person result = Find(personID);

                if (result != null)
                {
                    PersonServices.Delete(personID);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public bool DeleteReserves(int personID)
        {
            bool status = true;

            try
            {
                foreach (Reserve item in PersonServices.GetReserves(personID))
                {
                    status = ReserveController.Delete(item.ReserveID);
                    if (!status)
                        break;
                }
            }
            catch
            {
                status = false;
            }

            return status;
        }

        public Person Find(int personID)
        {
            Person result = null;

            try
            {
                result = PersonServices.Find(personID);
            }
            catch
            {
            }

            return result;
        }

        public List<Person> FindAll()
        {
            List<Person> results = null;

            try
            {
                results = PersonServices.FindAll();
            }
            catch
            {
            }

            return results;
        }

        public int GetUserID(string username)
        {
            int userID = 0;

            try
            {
                userID = PersonServices.GetUserID(username).PersonID;
            }
            catch
            {
            }

            return userID;
        }

        public List<Reserve> GetReserves(int personID)
        {
            List<Reserve> results = null;

            try
            {
                results = PersonServices.GetReserves(personID);
            }
            catch
            {
            }

            return results;
        }

        public ICollection SelectWithParent()
        {
            ICollection results = null;

            try
            {
                results = PersonServices.SelectWithParent();
            }
            catch
            {
            }

            return results;
        }

        public bool Login(string userName, string password)
        {
            bool status = false;

            try
            {
                Person result = PersonServices.Login(userName, password);

                if (result != null)
                    status = true;
            }
            catch
            {
            }

            return status;
        }

        public bool IsExistUserName(string username)
        {
            bool status = false;

            try
            {
                Person result = PersonServices.GetUserID(username);

                if (result != null)
                    status = true;
            }
            catch
            {
            }

            return status;
        }

        public bool IsPermissionToPage(string userName, string pageName)
        {
            bool status = false;

            try
            {
                ICollection result = PersonServices.GetPermissionToPage(userName, pageName);

                if (result.Count > 0)
                    status = true;
            }
            catch
            {
            }

            return status;
        }
    }
}