﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using Persist.Services;
using System.Collections;

namespace Business.Controller
{
    public class ReserveController
    {
        ReserveServices ReserveServices;

        public ReserveController()
        {
            this.ReserveServices = new ReserveServices();
        }

        public bool Create(Reserve reserve)
        {
            bool status = false;

            try
            {
                if (reserve.StartDate.Year * 365 + reserve.StartDate.Month * 31 + reserve.StartDate.Day <=
                  reserve.EndDate.Year * 365 + reserve.EndDate.Month * 31 + reserve.EndDate.Day)
                {
                    //اگر اتاق رزرو نشده بود بعد اتاق می تواند رزرو شود
                    if (!IsReserveRoom(reserve.StartDate, reserve.EndDate, reserve.Room_ID))
                    {
                        double price = ReserveServices.GetPriceReserve(reserve.Room_ID);
                        reserve.PriceSum = price;

                        ReserveServices.Create(reserve);
                        status = true;
                    }
                }
            }
            catch
            {
            }

            return status;
        }

        public bool Update(Reserve reserve)
        {
            bool status = false;

            try
            {
                Reserve result = Find(reserve.ReserveID);

                if (result != null)
                {
                    ReserveServices.Update(reserve);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public bool Delete(int reserveID)
        {
            bool status = false;

            try
            {
                Reserve result = Find(reserveID);

                if (result != null)
                {
                    ReserveServices.Delete(reserveID);
                    status = true;
                }
            }
            catch
            {
            }

            return status;
        }

        public Reserve Find(int reserveID)
        {
            Reserve result = null;

            try
            {
                result = ReserveServices.Find(reserveID);
            }
            catch
            {
            }

            return result;
        }

        public List<Reserve> FindAll()
        {
            List<Reserve> results = null;

            try
            {
                results = ReserveServices.FindAll();
            }
            catch
            {
            }

            return results;
        }

        public ICollection SelectWithParent()
        {
            ICollection results = null;

            try
            {
                results = ReserveServices.SelectWithParent();
            }
            catch
            {
            }

            return results;
        }

        public bool IsReserveRoom(DateTime startDate, DateTime endDate, int roomId)
        {
            bool status = true;

            try
            {
                List<Reserve> reserves = ReserveServices.GetReserveBetweenDateTime(startDate, endDate, roomId);

                if (reserves.Count == 0)
                {
                    status = false;
                }
            }
            catch
            {
            }

            return status;
        }
    }
}