﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using System.Collections;

namespace Persist.Services
{
    public class AccessServices
    {
        HotelSiteEntities Context;

        public AccessServices()
        {
            this.Context = new HotelSiteEntities();
        }

        public void Create(Access access)
        {
            Context.Accesses.AddObject(access);
            Context.SaveChanges();
        }

        public void Update(Access access)
        {
            Access result = Find(access.AccessID);

            result.UserType_ID = access.UserType_ID;
            result.Page_ID = access.Page_ID;

            Context.SaveChanges();
        }

        public void Delete(int accessID)
        {
            Access result = Find(accessID);

            Context.Accesses.DeleteObject(result);
            Context.SaveChanges();
        }

        public Access Find(int accessID)
        {
            Access result = Context.Accesses.Where(r => r.AccessID == accessID).SingleOrDefault();
            return result;
        }

        public List<Access> FindAll()
        {
            List<Access> results = Context.Accesses.Select(r => r).ToList();
            return results;
        }

        public ICollection SelectWithParent()
        {
            ICollection results = Context.Accesses.Select(r => new
            {
                AccessID = r.AccessID,
                UserType_Title = r.UserType.Title,
                Page_PageName = r.Page.PageName
            }).ToList();
            return results;
        }
        public void RefreshContext()
        {
            Context = new HotelSiteEntities();
        }
    }
}