﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Persist.Model;
using System.Collections;

namespace Persist.Services
{
    public class UserTypeServices
    {
        HotelSiteEntities Context;

        public UserTypeServices()
        {
            this.Context = new HotelSiteEntities();
        }

        public void Create(UserType userType)
        {
            Context.UserTypes.AddObject(userType);
            Context.SaveChanges();
        }

        public void Update(UserType userType)
        {
            UserType result = Find(userType.UserTypeID);

            result.Title = userType.Title;

            Context.SaveChanges();
        }

        public void Delete(int userTypeID)
        {
            UserType result = Find(userTypeID);

            Context.UserTypes.DeleteObject(result);
            Context.SaveChanges();
        }

        public UserType Find(int userTypeID)
        {
            UserType result = Context.UserTypes.Where(r => r.UserTypeID == userTypeID).SingleOrDefault();
            return result;
        }

        public List<UserType> FindAll()
        {
            List<UserType> results = Context.UserTypes.Select(r => r).ToList();
            return results;
        }


        public List<Person> GetPeople(int userType_ID)
        {
            List<Person> results = Context.People.Where(r => r.UserType_ID == userType_ID).ToList();
            return results;
        }

        public List<Access> GetAccesses(int userType_ID)
        {
            List<Access> results = Context.Accesses.Where(r => r.UserType_ID == userType_ID).ToList();
            return results;
        }
        public void RefreshContext()
        {
            Context = new HotelSiteEntities();
        }
    }
}