﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Business.Classes;
using Business.Controller;

namespace Presentation.Pages.Admin
{
    public partial class Report2 : System.Web.UI.Page
    {
        DateTimeBusiness DateTimeBusiness;
        RoomController RoomController;
        PersonController PersonController;

        public Report2()
        {
            DateTimeBusiness = new DateTimeBusiness();
            RoomController = new RoomController();
            PersonController = new PersonController();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!PersonController.IsPermissionToPage(HttpContext.Current.User.Identity.Name, this.Title))
                Response.Redirect("~/Pages/Forbidden.aspx");
        }

        protected void btnSearch_Click(object sender, EventArgs e)
        {
            if (Page.IsValid)
            {
                grdRooms.DataSource = RoomController.ReportOfEmptyRoom(DateTimeBusiness.ConvertToMilady(pdtStartDate.Text),
                                                                       DateTimeBusiness.ConvertToMilady(pdtEndDate.Text));
                grdRooms.DataBind();
            }
        }

        protected void cvStartDate_ServerValidate(object source, ServerValidateEventArgs args)
        {
            DateTime dateSelected = DateTimeBusiness.ConvertToMilady(pdtStartDate.Text);
            DateTime dateNow = DateTime.Now;

            args.IsValid = (dateSelected.Year * 365 + dateSelected.Month * 31 + dateSelected.Day >=
                            dateNow.Year * 365 + dateNow.Month * 31 + dateNow.Day) ? true : false;
        }
    }
}